Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleighModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleighModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleighModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PenelopeRayleighModel.cc,v 1.2 2008/12/04 14:09:36 pandola Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PenelopeRayleighModel.cc,v 1.4 2009/05/19 14:57:01 pandola Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: Luciano Pandola
@@ -32,4 +32,9 @@
 // --------
 // 14 Oct 2008   L Pandola    Migration from process to model 
+// 17 Apr 2009   V Ivanchenko Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+// 19 May 2009   L Pandola    Explicitely set to zero pointers deleted in 
+//                            PrepareConstants(), since they might be checked later on
 //
 
@@ -56,5 +61,5 @@
   fIntrinsicLowEnergyLimit = 100.0*eV;
   fIntrinsicHighEnergyLimit = 100.0*GeV;
-  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
+  //  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
   SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
   //
@@ -90,29 +95,15 @@
     G4cout << "Calling G4PenelopeRayleighModel::Initialise()" << G4endl;
 
-  if (LowEnergyLimit() < fIntrinsicLowEnergyLimit)
-    {
-      G4cout << "G4PenelopeRayleighModel: low energy limit increased from " << 
-	LowEnergyLimit()/eV << " eV to " << fIntrinsicLowEnergyLimit/eV << " eV" << G4endl;
-      SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
-    }
-  if (HighEnergyLimit() > fIntrinsicHighEnergyLimit)
-    {
-      G4cout << "G4PenelopeRayleighModel: high energy limit decreased from " << 
-	HighEnergyLimit()/GeV << " GeV to " << fIntrinsicHighEnergyLimit/GeV << " GeV" << G4endl;
-      SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
-    }
-
-  G4cout << "Penelope Rayleigh model is initialized " << G4endl
-         << "Energy range: "
-         << LowEnergyLimit() / keV << " keV - "
-         << HighEnergyLimit() / GeV << " GeV"
-         << G4endl;
+
+  if (verboseLevel > 0) {
+    G4cout << "Penelope Rayleigh model is initialized " << G4endl
+	   << "Energy range: "
+	   << LowEnergyLimit() / keV << " keV - "
+	   << HighEnergyLimit() / GeV << " GeV"
+	   << G4endl;
+  }
 
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
+  fParticleChange = GetParticleChangeForGamma();
   isInitialised = true;
 }
@@ -120,9 +111,10 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-G4double G4PenelopeRayleighModel::CrossSectionPerVolume(const G4Material* material,
-                                           const G4ParticleDefinition* p,
-                                           G4double ekin,
-                                           G4double,
-                                           G4double)
+G4double 
+G4PenelopeRayleighModel::CrossSectionPerVolume(const G4Material* material,
+					       const G4ParticleDefinition* p,
+					       G4double ekin,
+					       G4double,
+					       G4double)
 {
   // Penelope model to calculate the Rayleigh scattering inverse mean 
@@ -233,8 +225,8 @@
 
 void G4PenelopeRayleighModel::SampleSecondaries(std::vector<G4DynamicParticle*>* ,
-					      const G4MaterialCutsCouple* couple,
-					      const G4DynamicParticle* aDynamicGamma,
-					      G4double,
-					      G4double)
+						const G4MaterialCutsCouple* couple,
+						const G4DynamicParticle* aDynamicGamma,
+						G4double,
+						G4double)
 {
   // Penelope model to sample the Rayleigh scattering final state.
@@ -249,14 +241,14 @@
   if (verboseLevel > 3)
     G4cout << "Calling SamplingSecondaries() of G4PenelopeRayleighModel" << G4endl;
-                                                                                                    
+
   G4double photonEnergy0 = aDynamicGamma->GetKineticEnergy();
  
-  if (photonEnergy0 <= LowEnergyLimit())
-  {
+  if (photonEnergy0 <= fIntrinsicLowEnergyLimit)
+    {
       fParticleChange->ProposeTrackStatus(fStopAndKill);
       fParticleChange->SetProposedKineticEnergy(0.);
       fParticleChange->ProposeLocalEnergyDeposit(photonEnergy0);
       return ;
-  }
+    }
 
   G4ParticleMomentum photonDirection0 = aDynamicGamma->GetMomentumDirection();
@@ -534,8 +526,14 @@
   Xhigh=1e06;
   if (samplingFunction_x)
-    delete samplingFunction_x;
+    {
+      delete samplingFunction_x;
+      samplingFunction_x = 0;
+    }
   if (samplingFunction_xNoLog)
-    delete samplingFunction_xNoLog;
- 
+    {
+      delete samplingFunction_xNoLog;
+      samplingFunction_xNoLog = 0;
+    }
+
   samplingFunction_x = new G4DataVector();
   samplingFunction_xNoLog = new G4DataVector();
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4ShellVacancy.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4ShellVacancy.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4ShellVacancy.cc	(revision 1055)
@@ -50,4 +50,5 @@
 
 {
+/*
   G4int size = xsis.size();
   for (G4int k =0; k<size; k++)
@@ -56,10 +57,10 @@
       xsis[k] = 0;
     }
+*/
 }
 
-void G4ShellVacancy::AddXsiTable(G4VEMDataSet* set)
-
+void G4ShellVacancy::AddXsiTable(G4VEMDataSet* p)
 {
-  xsis.push_back(set);
+  xsis.push_back(p);
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationCrossSectionHandler.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationCrossSectionHandler.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationCrossSectionHandler.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eIonisationCrossSectionHandler.cc,v 1.11 2006/06/29 19:42:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eIonisationCrossSectionHandler.cc,v 1.12 2009/01/29 08:13:34 pandola Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -42,4 +42,6 @@
 // 19 Jul 2002   VI          Create composite data set for material
 // 21 Jan 2003  V.Ivanchenko Cut per region
+// 28 Jan 2009  L.Pandola    Added public method to make a easier migration of 
+//                           G4LowEnergyIonisation to G4LivermoreIonisationModel
 //
 // -------------------------------------------------------------------
@@ -98,9 +100,10 @@
     G4int nElements = material->GetNumberOfElements();
 
-    if(verbose > 0) {
-      G4cout << "eIonisation CS for " << m << "th material "
-             << material->GetName()
-             << "  eEl= " << nElements << G4endl;
-    }
+    if(verbose > 0) 
+      {
+	G4cout << "eIonisation CS for " << m << "th material "
+	       << material->GetName()
+	       << "  eEl= " << nElements << G4endl;
+      }
 
     G4double tcut  = (*energyCuts)[m];
@@ -129,5 +132,6 @@
             value += cross * p * density;
 
-            if(verbose>0 && m == 0 && e>=1. && e<=0.) {
+	    if(verbose>0 && m == 0 && e>=1. && e<=0.) 
+	    {
               G4cout << "G4eIonCrossSH: e(MeV)= " << e/MeV
                      << " n= " << n
@@ -139,5 +143,5 @@
                      << " Z= " << Z
                      << G4endl;
-	    }
+	      }
 
 	  }
@@ -155,3 +159,18 @@
 }
 
-
+G4double G4eIonisationCrossSectionHandler::GetCrossSectionAboveThresholdForElement(G4double energy,
+										   G4double cutEnergy,
+										   G4int Z)
+{
+  G4int nShells = NumberOfComponents(Z);
+  G4double value = 0.;
+  if(energy > cutEnergy) 
+    {
+      for (G4int n=0; n<nShells; n++) {
+	G4double cross = FindValue(Z, energy, n);
+	G4double p = theParam->Probability(Z, cutEnergy, energy, energy, n);
+	value += cross * p;
+      }
+    }
+  return value;
+}
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationParameters.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationParameters.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationParameters.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4eIonisationParameters.cc,v 1.23 2006/06/29 19:42:02 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eIonisationParameters.cc,v 1.24 2009/03/23 09:13:44 pandola Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
@@ -41,4 +41,5 @@
 //                          chenged to "ion-..."
 // 17.02.04 V.Ivanchenko    Increase buffer size
+// 23.03.09 L.Pandola       Updated warning message
 //
 // -------------------------------------------------------------------
@@ -199,5 +200,5 @@
     if (! (lsdp->is_open()) ) {
       G4String excep = G4String("G4IonisationParameters - data file: ")
-      + name + G4String(" not found. The version 1.# of G4LEDATA should be used");
+      + name + G4String(" not found. Please check and/or update G4LEDATA");
       G4Exception(excep);
     }
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationSpectrum.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationSpectrum.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4eIonisationSpectrum.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4eIonisationSpectrum.cc,v 1.25 2006/06/29 19:42:04 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4eIonisationSpectrum.cc,v 1.26 2009/03/23 09:13:44 pandola Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -46,4 +46,6 @@
 // 30.05.2002 VI            Update to 24-parameters data
 // 11.07.2002 VI            Fix in integration over spectrum
+// 23.03.2009 LP            Added protection against division by zero (for 
+//                          faulty database files), Bug Report 1042
 //
 // -------------------------------------------------------------------
@@ -125,5 +127,14 @@
   p.push_back((2.0*g - 1.0)/(g*g));
   
-  p[iMax-1] = Function(p[3], p);
+  //Add protection against division by zero: actually in Function() 
+  //parameter p[3] appears in the denominator. Bug report 1042
+  if (p[3] > 0)
+    p[iMax-1] = Function(p[3], p);
+  else
+    {
+      G4cout << "WARNING: G4eIonisationSpectrum::Probability "
+	     << "parameter p[3] <= 0. G4LEDATA dabatase might be corrupted for Z = " 
+	     << Z << ". Please check and/or update it " << G4endl;      
+    }
 
   if(e >= 1. && e <= 0. && Z == 4) p.push_back(0.0);
@@ -210,5 +221,15 @@
   p.push_back((2.0*g - 1.0)/(g*g));
 
-  p[iMax-1] = Function(p[3], p);
+  
+  //Add protection against division by zero: actually in Function() 
+  //parameter p[3] appears in the denominator. Bug report 1042
+  if (p[3] > 0)
+    p[iMax-1] = Function(p[3], p);
+  else
+    {
+      G4cout << "WARNING: G4eIonisationSpectrum::AverageEnergy "
+	     << "parameter p[3] <= 0. G4LEDATA dabatase might be corrupted for Z = " 
+	     << Z << ". Please check and/or update it " << G4endl;      
+    }
     
   G4double val = AverageValue(x1, x2, p);
@@ -288,5 +309,15 @@
   p.push_back((2.0*g - 1.0)/(g*g));
 
-  p[iMax-1] = Function(p[3], p);
+  
+  //Add protection against division by zero: actually in Function() 
+  //parameter p[3] appears in the denominator. Bug report 1042
+  if (p[3] > 0)
+    p[iMax-1] = Function(p[3], p);
+  else
+    {
+      G4cout << "WARNING: G4eIonisationSpectrum::SampleSpectrum "
+	     << "parameter p[3] <= 0. G4LEDATA dabatase might be corrupted for Z = " 
+	     << Z << ". Please check and/or update it " << G4endl;      
+    }
 
   G4double aria1 = 0.0;
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyLoss.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyLoss.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4hLowEnergyLoss.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4hLowEnergyLoss.cc,v 1.27 2008/06/20 19:54:03 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4hLowEnergyLoss.cc,v 1.28 2009/02/20 10:49:54 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -----------------------------------------------------------
@@ -145,5 +145,6 @@
 G4double G4hLowEnergyLoss::HighestKineticEnergy= 100.*GeV;
 G4int    G4hLowEnergyLoss::TotBin = 360;
-G4double G4hLowEnergyLoss::RTable,G4hLowEnergyLoss::LOGRTable;
+G4double G4hLowEnergyLoss::RTable =1.1;
+G4double G4hLowEnergyLoss::LOGRTable = 1.1;
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
@@ -772,5 +773,4 @@
     theRangeTable = theRangepbarTable ;
   }
- 
   G4double R2 = RTable*RTable ;
   G4double R1 = RTable+1.;
@@ -1062,5 +1062,6 @@
 {
   G4double LowEdgeRange,A,B,C,discr,KineticEnergy ;
-  G4double Tbin = LowestKineticEnergy/RTable ;
+  G4double Tbin = 0;
+  if (RTable !=0.) Tbin = LowestKineticEnergy/RTable ;
   G4double rangebin = 0.0 ;
   G4int binnumber = -1 ;
